// File    : CSTMSGVL.CPP
// Author  : Eric Woodruff,  CIS ID: 72134,1150
// Updated : Tue 01/24/95 20:37:28
// Note    : Hereby declared public domain
// Compiler: Borland C++ 3.1 to 4.xx
//
// This is identical to the standard TPXPictureValidator class, but it will
// allow you to specify the error message that is displayed.  The concepts
// here can be incorporated into any of the other validators.  All you need
// to do is pass the constructor a message string and override the error()
// method to display your own message.
//

#define Uses_MsgBox
#define Uses_TPXPictureValidator
#include <tv.h>

#define Uses_TPXCustMsgValidator
#include <custmval.h>

TPXCustMsgValidator::TPXCustMsgValidator(const char *aPic, Boolean autoFill,
  const char *aMsg) :
    TPXPictureValidator(aPic, autoFill)
{
    msgString = newStr(aMsg);
}

void TPXCustMsgValidator::error(void)
{
    // If msgString is NULL, no message is displayed.  This can be useful
    // for situations where data is manipulated in some fashion and focus
    // is returned to the same field but no error message needs to be
    // displayed.
    if(msgString)
        messageBox(mfError | mfCancelButton, msgString);
}

#if !defined(NO_STREAMABLE)

TPXCustMsgValidator::TPXCustMsgValidator( StreamableInit s) :
    TPXPictureValidator(s)
{
}

void TPXCustMsgValidator::write(opstream &os)
{
    TPXPictureValidator::write( os );
    os.writeString(msgString);
}

void *TPXCustMsgValidator::read(ipstream &is)
{
    TPXPictureValidator::read( is );
    msgString = is.readString();
    return this;
}

TStreamable *TPXCustMsgValidator::build()
{
    return new TPXCustMsgValidator( streamableInit );
}

#endif
